TSILF[type_, args_, ss_, q_] := 
  Block[{x, y, z, u, v, s, qq, Mxyzuv, Uzxyv, Uuyxv, Uxzuv, Uyuzv, 
    Tvyz, Tuxv, Tyzv, Txuv, Tzyv, Tvxu, Svyz, Suxv, Bxz, Byu, Vzxyv, 
    Vuyxv, Vxzuv, Vyuzv, TBARvyz, TBARuxv, TBARyzv, TBARxuv, TBARzyv, 
    TBARvxu, Ixyv, Izuv, Ax, Ay, Az, Au, Av, Bepsxz, Bepsyu, Aepsx, 
    Aepsy, Aepsz, Aepsu, Aepsv, UUzxyv0, UUzxyv1, UUzxyv2, UUuyxv0, 
    UUuyxv1, UUuyxv2, UUxzuv0, UUxzuv1, UUxzuv2, UUyuzv0, UUyuzv1, 
    UUyuzv2, VVzxyv0, VVzxyv1, VVzxyv2, VVuyxv0, VVuyxv1, VVuyxv2, 
    VVxzuv0, VVxzuv1, VVxzuv2, VVyuzv0, VVyuzv1, VVyuzv2, TTvyz0, 
    TTvyz1, TTvyz2, TTuxv0, TTuxv1, TTuxv2, TTyzv0, TTyzv1, TTyzv2, 
    TTxuv0, TTxuv1, TTxuv2, TTzyv0, TTzyv1, TTzyv2, TTvxu0, TTvxu1, 
    TTvxu2, SSvyz0, SSvyz1, SSvyz2, SSuxv0, SSuxv1, SSuxv2, argstring,
     fiveargs, sevenargs, res, file, sfile},
   If[! ValueQ[$TSILexec],
    Print["Need to specify TSIL executable via variable $TSILexec!"];
    Return[0];
    ];
   Switch[type,
    M,
    fiveargs = args,
    U | V,
    fiveargs = {args[[1]], q, args[[2]], args[[3]], args[[4]]};,
    S | T | TBAR,
    fiveargs = {args[[1]], q, q, args[[2]], args[[3]]};,
    II,
    fiveargs = {args[[1]], args[[2]], q, q, args[[3]]};,
    A,
    fiveargs = {args[[1]], q, q, q, q};,
    B,
    fiveargs = {args[[1]], q, args[[2]], q, q};,
    _,
    fiveargs = PadRight[args, 5, q];
    ];
   
   sevenargs = Join[fiveargs, {ss, q}];
   argstring = StringJoin @@ Riffle[ToString /@ sevenargs, " "];
   
   file = CreateFile[];
   sfile = ToString[file];
   
   Run[$TSILexec <> " " <> argstring <> " > " <> sfile];
   Run["sed --in-place '/time/d' " <> sfile];
   Get[file];
   DeleteFile[file];
   
   Switch[type,
    M,
    res = Mxyzuv,
    U,
    res = Uxzuv,
    V,
    res = Vxzuv,
    T,
    res = Txuv,
    TBAR,
    res = TBARxuv,
    S,
    res = Suxv,
    II,
    res = Ixyv,
    A,
    res = Ax,
    B,
    res = Bxz,
    _,
    res = 0;
    ];
   Return[res];
   ];

TSILEvaluate[exp_,P2_,Q2_]:=
Block[{funcs,ii,type,args,val,valreplist,ss},
      funcs=Union[Cases[exp,_B0fin|_SMI|_SMS|_SMTT|_SMTbar|_SMU|_SMM|_SMV,Infinity]];
      valreplist={};
      For[ii=1,ii<=Length[funcs],ii++,
	  type=Head[funcs[[ii]]]/.{B0fin->B,SMI->II,SMS->S,SMTT->T,SMTbar->TBAR,SMU->U,SMV->V,SMM->M};
	  args=List@@funcs[[ii]];
	  If[type===B,
	     If[args[[1]]===p2,
		ss=P2,
		ss=args[[1]]
	       ];
	     args=Drop[args,1];
	     ,
	     ss=P2;
	    ];
	  val=TSILF[type,args,ss,Q2];
	  AppendTo[valreplist,funcs[[ii]]->val];
	 ];
      Return[exp/.valreplist]
];