BeginPackage["TLDR`"]

StartingDirectory= Directory[]

$tldrPath=SetDirectory[DirectoryName[System`Private`FindFile[$Input]]]

ResetDirectory[]

$tldrPackageDir=ToFileName[{$tldrPath,"Package"}]
$tldrRepoDir=ToFileName[{$tldrPath,"Repository"}]
$tldrRulesDir=ToFileName[{$tldrPackageDir,"Rules"}]

expandanint::usage

Print["Loading TLDR"];
Print["Two Loop Diagram Repository"];
Print["Written by Mark Goodsell and Sebastian Passehr"];

Block[{$Path = {$tldrPackageDir}},

Get[ToFileName[$tldrRulesDir,"ExpandDel.m"]];
newtyrules=Get[ToFileName[$tldrRulesDir,"TarcerRulesYExpanded.m"]];
newttrules=Get[ToFileName[$tldrRulesDir,"TarcerRulesTExpanded.m"]];
newtcrules=Get[ToFileName[$tldrRulesDir,"TwoCalcRulesExpanded.m"]];
myextraTreps=Get[ToFileName[$tldrRulesDir,"ExtraTReps.m"]];
<<TSILrules`;
<<TSILMath`;


Get[ToFileName[$tldrRulesDir,"ExtraDivRules.m"]];
      
yintreds=Get[ToFileName[$tldrRulesDir,"SS_Yintred.m"]];
p2intreds=Join[Get[ToFileName[$tldrRulesDir, "SS_p2intred.m"]],Get[ToFileName[$tldrRulesDir, "1LCT_SS_p2intred.m"]]];
ssintreds=Join[Get[ToFileName[$tldrRulesDir,"SS_intred.m"]], 
   Get[ToFileName[$tldrRulesDir,"S_intred.m"]]];

ctintreds=Join[Get[ToFileName[$tldrRulesDir,"1LCT_SS_intred.m"]], 
	       Get[ToFileName[$tldrRulesDir,"1LCT_S_intred.m"]]];


<<expandanint`;
      
unexpSS =Get[ToFileName[{$tldrRepoDir,"Feynman","Uncombined"},"RAW_unexpanded_FG_SS.m"]];
unexpS=Get[ToFileName[{$tldrRepoDir,"Feynman","Uncombined"},"RAW_unexpanded_FG_S.m"]];
combinedSS=Get[ToFileName[{$tldrRepoDir,"Feynman","Combined"},"COMBINED_unexpanded_FG_SS.m"]];

];



Print["TLDR packages loaded!"];

EndPackage[]